import Vue from 'vue'
import App from './App.vue'
import store from '@/store'
import eruda from 'eruda'
import { router, RouterMount } from './router'
import '@/components/register'

import { VuexMixin } from '@/store/$u.mixin'

Vue.config.productionTip = false

Vue.use(router)
Vue.mixin(VuexMixin)

// if (process.env.VUE_APP_ENV === 'test') {
// 默认开启eruda调试台，这里可以用环境变量判断开启关闭
eruda.init()
// }

const app = new App({
  store
})

// http拦截器，将此部分放在new Vue()和app.$mount()之间，才能App.vue中正常使用
import httpInterceptor from '@/common/http.interceptor'
Vue.use(httpInterceptor, app)

// http接口API集中管理引入部分
import httpApi from '@/common/http.api'
Vue.use(httpApi, app)

// #ifdef H5
RouterMount(app, router, '#app')
// #endif

// #ifndef H5
app.$mount() // 为了兼容小程序及app端必须这样写才有效果
// #endif
