interface UView {
  /**
     * uview为uniapp的uni.showToast的二次封装
     * @param title toast的消息内容
     * @param duration toast出现到消失的时间，单位ms，默认1500ms
     */
  toast(title: string, duration?: number): void
  /**
  * 此属性用于返回平台的名称，为小写的ios或android
  */
  os(): string
  /**
  * 此属性用于获取设备的信息，相当于uni.getSystemInfoSync()的效果
  */
  // eslint-disable-next-line no-undef
  sys(): UniNamespace.GetSystemInfoResult
  queryParams(data: any, isPrefix?: boolean, arrayFormat?: string): string
  route(options: any, params: any): void
  timeFormat(dateTime: null, fmt?: ('yyyy-mm-dd'|string)): string
  guid: any
  color: any
  type2icon: any
  randomArray: any
  wranning: any
  get: any
  post: any
  put: any
  hexToRgb: any
  rgbToHex: any
  random: any
  deepClone: Function
  deepMerge: Function
  getParent: Function
  $parent: any
  trim: Function
  http: any
  config: any // uView配置信息相关，比如版本号
  zIndex: any
  debounce: Function
  throttle: Function
}

export interface $u extends UView {
  /**
   * 使用方法为：如果要修改vuex的state中的user.name变量为"史诗" => this.$u.vuex('user.name', '史诗')
   * 如果要修改vuex的state的version变量为1.0.1 => this.$u.vuex('version', '1.0.1')
   * @param name 对应vux中state的key，可以使用.分隔以修改深层属性
   * @param value 值
   */
  vuex(name: string, value: any): void
  // rpx转换为px
  rpx2px(rpx: number): number
  // px转换为rpx
  px2rpx(rpx: number): number
}
