import { RouterMount, createRouter, RoutesRule } from 'uni-simple-router'
const pages = require('./pages.ts')

const RouterPages: RoutesRule[] = [
  ...pages
].map((item: RoutesRule) => ({
  path: `/${item.path}`,
  meta: item.meta || {},
  name: item.name,
  style: item.style
}))

const router = createRouter({
  platform: process.env.VUE_APP_PLATFORM as any,
  routes: [...RouterPages, {
    path: '*',
    redirect: (to: RoutesRule) => {
      return { name: '404' }
    }
  }]
})

// 路由前置守卫
router.beforeEach((to, from, next) => {
  next()
})

// 路由后置守卫
router.afterEach((to, from) => {
  // console.log('跳转结束')
})

export {
  router,
  RouterMount
}
